/*
  * #%L
  * Quadrige3 Core
  * %%
  * Copyright (C) 2017 Ifremer
  * %%
  * This program is free software: you can redistribute it and/or modify
  * it under the terms of the GNU Affero General Public License as published by
  * the Free Software Foundation, either version 3 of the License, or
  * (at your option) any later version.
  *
  * This program is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU General Public License for more details.
  *
  * You should have received a copy of the GNU Affero General Public License
  * along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * #L%
  */
//
/**
 * @author Generated on 07/06/2018 09:09:12+0200 Do not modify by hand!
 *
 * TEMPLATE:     ValueObject.vsl in andromda-java-cartridge.
 * MODEL CLASS:  Données::fr.ifremer.quadrige3.core::vo::system::rule::RuleVO
 * STEREOTYPE:   ValueObject
 */
package fr.ifremer.quadrige3.core.vo.system.rule;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.Arrays;
import org.apache.commons.lang3.builder.CompareToBuilder;
import org.apache.commons.lang3.builder.EqualsBuilder;
import org.apache.commons.lang3.builder.HashCodeBuilder;
import org.apache.commons.lang3.builder.ToStringBuilder;

/**
 * TODO: Model Documentation for class RuleVO
 */
public class RuleVO
    implements Serializable, Comparable<RuleVO>
{
    /** The serial version UID of this class. Needed for serialization. */
    private static final long serialVersionUID = 9147838804589316449L;

    // Class attributes
    /** TODO: Model Documentation for attribute ruleCd */
    protected String ruleCd;
    /** TODO: Model Documentation for attribute ruleControledAttribut */
    protected String ruleControledAttribut;
    /** TODO: Model Documentation for attribute ruleDc */
    protected String ruleDc;
    /** TODO: Model Documentation for attribute ruleIsActive */
    protected String ruleIsActive;
    /** TODO: Model Documentation for attribute ruleIsBlocking */
    protected String ruleIsBlocking;
    /** TODO: Model Documentation for attribute ruleErrorMsg */
    protected String ruleErrorMsg;
    /** TODO: Model Documentation for attribute updateDt */
    protected Timestamp updateDt;
    /** TODO: Model Documentation for attribute ruleListCd */
    protected String ruleListCd;
    /** TODO: Model Documentation for attribute functionId */
    protected Integer functionId;

    // Class associationEnds
    /** TODO: Model Documentation for attribute rulePreconditionVO */
    protected RulePreconditionVO rulePreconditionVO;

    /** TODO: Model Documentation for attribute ruleListVO */
    protected RuleListVO ruleListVO;

    /** TODO: Model Documentation for attribute rulePmfmVOs */
    protected RulePmfmVO[] rulePmfmVOs;

    /** TODO: Model Documentation for attribute ruleParameterVOs */
    protected RuleParameterVO[] ruleParameterVOs;

    /** Default Constructor with no properties */
    public RuleVO()
    {
        // Documented empty block - avoid compiler warning - no super constructor
    }

    /**
     * Constructor taking only required properties
     * @param ruleCdIn String
     * @param ruleControledAttributIn String
     * @param ruleListCdIn String
     * @param functionIdIn Integer
     * @param ruleListVOIn RuleListVO
     */
    public RuleVO(final String ruleCdIn, final String ruleControledAttributIn, final String ruleListCdIn, final Integer functionIdIn, final RuleListVO ruleListVOIn)
    {
        this.ruleCd = ruleCdIn;
        this.ruleControledAttribut = ruleControledAttributIn;
        this.ruleListCd = ruleListCdIn;
        this.functionId = functionIdIn;
        this.ruleListVO = ruleListVOIn;
    }

    /**
     * Constructor with all properties
     * @param ruleCdIn String
     * @param ruleControledAttributIn String
     * @param ruleDcIn String
     * @param ruleIsActiveIn String
     * @param ruleIsBlockingIn String
     * @param ruleErrorMsgIn String
     * @param updateDtIn Timestamp
     * @param ruleListCdIn String
     * @param functionIdIn Integer
     * @param rulePreconditionVOIn RulePreconditionVO
     * @param ruleListVOIn RuleListVO
     * @param rulePmfmVOsIn RulePmfmVO[]
     * @param ruleParameterVOsIn RuleParameterVO[]
     */
    public RuleVO(final String ruleCdIn, final String ruleControledAttributIn, final String ruleDcIn, final String ruleIsActiveIn, final String ruleIsBlockingIn, final String ruleErrorMsgIn, final Timestamp updateDtIn, final String ruleListCdIn, final Integer functionIdIn, final RulePreconditionVO rulePreconditionVOIn, final RuleListVO ruleListVOIn, final RulePmfmVO[] rulePmfmVOsIn, final RuleParameterVO[] ruleParameterVOsIn)
    {
        this.ruleCd = ruleCdIn;
        this.ruleControledAttribut = ruleControledAttributIn;
        this.ruleDc = ruleDcIn;
        this.ruleIsActive = ruleIsActiveIn;
        this.ruleIsBlocking = ruleIsBlockingIn;
        this.ruleErrorMsg = ruleErrorMsgIn;
        this.updateDt = updateDtIn;
        this.ruleListCd = ruleListCdIn;
        this.functionId = functionIdIn;
        this.rulePreconditionVO = rulePreconditionVOIn;
        this.ruleListVO = ruleListVOIn;
        this.rulePmfmVOs = rulePmfmVOsIn;
        this.ruleParameterVOs = ruleParameterVOsIn;
    }

    /**
     * Copies constructor from other RuleVO
     *
     * @param otherBean Cannot be <code>null</code>
     * @throws NullPointerException if the argument is <code>null</code>
     */
    public RuleVO(final RuleVO otherBean)
    {
        this.ruleCd = otherBean.getRuleCd();
        this.ruleControledAttribut = otherBean.getRuleControledAttribut();
        this.ruleDc = otherBean.getRuleDc();
        this.ruleIsActive = otherBean.getRuleIsActive();
        this.ruleIsBlocking = otherBean.getRuleIsBlocking();
        this.ruleErrorMsg = otherBean.getRuleErrorMsg();
        this.updateDt = otherBean.getUpdateDt();
        this.ruleListCd = otherBean.getRuleListCd();
        this.functionId = otherBean.getFunctionId();
        this.rulePreconditionVO = otherBean.getRulePreconditionVO();
        this.ruleListVO = otherBean.getRuleListVO();
        this.rulePmfmVOs = otherBean.getRulePmfmVOs();
        this.ruleParameterVOs = otherBean.getRuleParameterVOs();
    }

    /**
     * Copies all properties from the argument value object into this value object.
     * @param otherBean Cannot be <code>null</code>
     */
    public void copy(final RuleVO otherBean)
    {
        if (null != otherBean)
        {
            this.setRuleCd(otherBean.getRuleCd());
            this.setRuleControledAttribut(otherBean.getRuleControledAttribut());
            this.setRuleDc(otherBean.getRuleDc());
            this.setRuleIsActive(otherBean.getRuleIsActive());
            this.setRuleIsBlocking(otherBean.getRuleIsBlocking());
            this.setRuleErrorMsg(otherBean.getRuleErrorMsg());
            this.setUpdateDt(otherBean.getUpdateDt());
            this.setRuleListCd(otherBean.getRuleListCd());
            this.setFunctionId(otherBean.getFunctionId());
            this.setRulePreconditionVO(otherBean.getRulePreconditionVO());
            this.setRuleListVO(otherBean.getRuleListVO());
            this.setRulePmfmVOs(otherBean.getRulePmfmVOs());
            this.setRuleParameterVOs(otherBean.getRuleParameterVOs());
        }
    }

    /**
     * TODO: Model Documentation for attribute ruleCd
     * Get the ruleCd Attribute
     * @return ruleCd String
     */
    public String getRuleCd()
    {
        return this.ruleCd;
    }

    /**
     * 
     * @param value String
     */
    public void setRuleCd(final String value)
    {
        this.ruleCd = value;
    }

    /**
     * TODO: Model Documentation for attribute ruleControledAttribut
     * Get the ruleControledAttribut Attribute
     * @return ruleControledAttribut String
     */
    public String getRuleControledAttribut()
    {
        return this.ruleControledAttribut;
    }

    /**
     * 
     * @param value String
     */
    public void setRuleControledAttribut(final String value)
    {
        this.ruleControledAttribut = value;
    }

    /**
     * TODO: Model Documentation for attribute ruleDc
     * Get the ruleDc Attribute
     * @return ruleDc String
     */
    public String getRuleDc()
    {
        return this.ruleDc;
    }

    /**
     * 
     * @param value String
     */
    public void setRuleDc(final String value)
    {
        this.ruleDc = value;
    }

    /**
     * TODO: Model Documentation for attribute ruleIsActive
     * Get the ruleIsActive Attribute
     * @return ruleIsActive String
     */
    public String getRuleIsActive()
    {
        return this.ruleIsActive;
    }

    /**
     * 
     * @param value String
     */
    public void setRuleIsActive(final String value)
    {
        this.ruleIsActive = value;
    }

    /**
     * TODO: Model Documentation for attribute ruleIsBlocking
     * Get the ruleIsBlocking Attribute
     * @return ruleIsBlocking String
     */
    public String getRuleIsBlocking()
    {
        return this.ruleIsBlocking;
    }

    /**
     * 
     * @param value String
     */
    public void setRuleIsBlocking(final String value)
    {
        this.ruleIsBlocking = value;
    }

    /**
     * TODO: Model Documentation for attribute ruleErrorMsg
     * Get the ruleErrorMsg Attribute
     * @return ruleErrorMsg String
     */
    public String getRuleErrorMsg()
    {
        return this.ruleErrorMsg;
    }

    /**
     * 
     * @param value String
     */
    public void setRuleErrorMsg(final String value)
    {
        this.ruleErrorMsg = value;
    }

    /**
     * TODO: Model Documentation for attribute updateDt
     * Get the updateDt Attribute
     * @return updateDt Timestamp
     */
    public Timestamp getUpdateDt()
    {
        return this.updateDt;
    }

    /**
     * 
     * @param value Timestamp
     */
    public void setUpdateDt(final Timestamp value)
    {
        this.updateDt = value;
    }

    /**
     * TODO: Model Documentation for attribute ruleListCd
     * Get the ruleListCd Attribute
     * @return ruleListCd String
     */
    public String getRuleListCd()
    {
        return this.ruleListCd;
    }

    /**
     * 
     * @param value String
     */
    public void setRuleListCd(final String value)
    {
        this.ruleListCd = value;
    }

    /**
     * TODO: Model Documentation for attribute functionId
     * Get the functionId Attribute
     * @return functionId Integer
     */
    public Integer getFunctionId()
    {
        return this.functionId;
    }

    /**
     * 
     * @param value Integer
     */
    public void setFunctionId(final Integer value)
    {
        this.functionId = value;
    }

    /**
     * TODO: Model Documentation for association rulePreconditionVO
     * Get the rulePreconditionVO Association
     * @return this.rulePreconditionVO RulePreconditionVO
     */
    public RulePreconditionVO getRulePreconditionVO()
    {
        return this.rulePreconditionVO;
    }

    /**
     * Sets the rulePreconditionVO
     * @param value RulePreconditionVO
     */
    public void setRulePreconditionVO(RulePreconditionVO value)
    {
        this.rulePreconditionVO = value;
    }

    /**
     * TODO: Model Documentation for association ruleListVO
     * Get the ruleListVO Association
     * @return this.ruleListVO RuleListVO
     */
    public RuleListVO getRuleListVO()
    {
        return this.ruleListVO;
    }

    /**
     * Sets the ruleListVO
     * @param value RuleListVO
     */
    public void setRuleListVO(RuleListVO value)
    {
        this.ruleListVO = value;
    }

    /**
     * TODO: Model Documentation for association rulePmfmVOs
     * Get the rulePmfmVOs Association
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the object.
     * @return this.rulePmfmVOs RulePmfmVO[]
     */
    public RulePmfmVO[] getRulePmfmVOs()
    {
        return this.rulePmfmVOs;
    }

    /**
     * Sets the rulePmfmVOs
     * @param value RulePmfmVO[]
     */
    public void setRulePmfmVOs(RulePmfmVO[] value)
    {
        this.rulePmfmVOs = value;
    }

    /**
     * TODO: Model Documentation for association ruleParameterVOs
     * Get the ruleParameterVOs Association
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the object.
     * @return this.ruleParameterVOs RuleParameterVO[]
     */
    public RuleParameterVO[] getRuleParameterVOs()
    {
        return this.ruleParameterVOs;
    }

    /**
     * Sets the ruleParameterVOs
     * @param value RuleParameterVO[]
     */
    public void setRuleParameterVOs(RuleParameterVO[] value)
    {
        this.ruleParameterVOs = value;
    }

    /**
     * @param object to compare this object against
     * @return boolean if equal
     * @see Object#equals(Object)
     */
    @Override
    public boolean equals(final Object object)
    {
        if (object==null || object.getClass() != this.getClass())
        {
             return false;
        }
        // Check if the same object instance
        if (object==this)
        {
            return true;
        }
        RuleVO rhs = (RuleVO) object;
        return new EqualsBuilder()
            .append(this.getRuleCd(), rhs.getRuleCd())
            .append(this.getRuleControledAttribut(), rhs.getRuleControledAttribut())
            .append(this.getRuleDc(), rhs.getRuleDc())
            .append(this.getRuleIsActive(), rhs.getRuleIsActive())
            .append(this.getRuleIsBlocking(), rhs.getRuleIsBlocking())
            .append(this.getRuleErrorMsg(), rhs.getRuleErrorMsg())
            .append(this.getUpdateDt(), rhs.getUpdateDt())
            .append(this.getRuleListCd(), rhs.getRuleListCd())
            .append(this.getFunctionId(), rhs.getFunctionId())
            .append(this.getRulePreconditionVO(), rhs.getRulePreconditionVO())
            .append(this.getRuleListVO(), rhs.getRuleListVO())
            .append(this.getRulePmfmVOs(), rhs.getRulePmfmVOs())
            .append(this.getRuleParameterVOs(), rhs.getRuleParameterVOs())
            .isEquals();
    }

    /**
     * @param object to compare this object against
     * @return int if equal
     * @see Comparable#compareTo(Object)
     */
    public int compareTo(final RuleVO object)
    {
        if (object==null)
        {
            return -1;
        }
        // Check if the same object instance
        if (object==this)
        {
            return 0;
        }
        return new CompareToBuilder()
            .append(this.getRuleCd(), object.getRuleCd())
            .append(this.getRuleControledAttribut(), object.getRuleControledAttribut())
            .append(this.getRuleDc(), object.getRuleDc())
            .append(this.getRuleIsActive(), object.getRuleIsActive())
            .append(this.getRuleIsBlocking(), object.getRuleIsBlocking())
            .append(this.getRuleErrorMsg(), object.getRuleErrorMsg())
            .append(this.getUpdateDt(), object.getUpdateDt())
            .append(this.getRuleListCd(), object.getRuleListCd())
            .append(this.getFunctionId(), object.getFunctionId())
            .append(this.getRulePreconditionVO(), object.getRulePreconditionVO())
            .append(this.getRuleListVO(), object.getRuleListVO())
            .append(this.getRulePmfmVOs(), object.getRulePmfmVOs())
            .append(this.getRuleParameterVOs(), object.getRuleParameterVOs())
            .toComparison();
    }

    /**
     * @return int hashCode value
     * @see Object#hashCode()
     */
    @Override
    public int hashCode()
    {
        return new HashCodeBuilder(1249046965, -82296885)
            .append(this.getRuleCd())
            .append(this.getRuleControledAttribut())
            .append(this.getRuleDc())
            .append(this.getRuleIsActive())
            .append(this.getRuleIsBlocking())
            .append(this.getRuleErrorMsg())
            .append(this.getUpdateDt())
            .append(this.getRuleListCd())
            .append(this.getFunctionId())
            .append(this.getRulePreconditionVO())
            .append(this.getRuleListVO())
            //Commented out to avoid commons-lang-2.4 recursion StackOverflowError: https://issues.apache.org/jira/browse/LANG-456
            //.append(this.getRulePmfmVOs())
            //Commented out to avoid commons-lang-2.4 recursion StackOverflowError: https://issues.apache.org/jira/browse/LANG-456
            //.append(this.getRuleParameterVOs())
            .toHashCode();
    }

    /**
     * @return String representation of object
     * @see Object#toString()
     */
    @Override
    public String toString()
    {
        return new ToStringBuilder(this)
            .append("ruleCd", this.getRuleCd())
            .append("ruleControledAttribut", this.getRuleControledAttribut())
            .append("ruleDc", this.getRuleDc())
            .append("ruleIsActive", this.getRuleIsActive())
            .append("ruleIsBlocking", this.getRuleIsBlocking())
            .append("ruleErrorMsg", this.getRuleErrorMsg())
            .append("updateDt", this.getUpdateDt())
            .append("ruleListCd", this.getRuleListCd())
            .append("functionId", this.getFunctionId())
            .append("rulePreconditionVO", this.getRulePreconditionVO())
            .append("ruleListVO", this.getRuleListVO())
            .append("rulePmfmVOs", this.getRulePmfmVOs())
            .append("ruleParameterVOs", this.getRuleParameterVOs())
            .toString();
    }

    /**
     * This is a convenient helper method which is able to detect whether or not two values are equal. Two values
     * are equal when they are both {@code null}, are arrays of the same length with equal elements or are
     * equal objects (this includes {@link java.util.Collection} and {@link java.util.Map} instances).
     *
     * <p/>Note that for array, collection or map instances the comparison runs one level deep.
     *
     * @param first the first object to compare, may be {@code null}
     * @param second the second object to compare, may be {@code null}
     * @return this method will return {@code true} in case both objects are equal as explained above;
     *      in all other cases this method will return {@code false}
     */
    protected static boolean equal(final Object first, final Object second)
    {
        final boolean equal;

        if (first == null)
        {
            equal = (second == null);
        }
        else if (first.getClass().isArray() && (second != null) && second.getClass().isArray())
        {
            equal = Arrays.equals((Object[])first, (Object[])second);
        }
        else // note that the following also covers java.util.Collection and java.util.Map
        {
            equal = first.equals(second);
        }

        return equal;
    }

    // RuleVO value-object java merge-point
}